import bb.cascades 1.3
import bb.data 1.0
import org.labsquare 1.0
import org.Hill 1.0
import bb.device 1.3

// Own profile page

Page {
    id: page
    signal urlChanged
    
    titleBar: TitleBar {
        kind: TitleBarKind.FreeForm
        kindProperties: FreeFormTitleBarKindProperties {
            Titlebar {
                id: titleBar
                titleText: "Profile"
            }
        }
        id: gamesTitle
        visibility: ChromeVisibility.Visible
    
    }
    
    Container {
        SegmentedControl {
            id: searchOptions
            
            Option {
                id: info
                text: "Info"
                selected: true
            }
            
            Option {
                id: chatOption
                text: "Chat"
            }
            
            onSelectedOptionChanged: {
                //queryData.clear()
                if(selectedOption == info){
                    chat.visible             = false
                    profilePage.visible       = true
                    
                
                }else{
                    chat.visible             = true
                    profilePage.visible       = false
                    
                }
            
            }
        }
        
        IrcChat {
            id: chat
            visible: false
            channel: o1.extraTokens.name
        }
        
       Profile {
           id: profilePage
       }
       
       
       RequestM {
           id: proReq
           authenticator: o1
       }
       
       RequestM {
           id: channelReq
       }
       
       attachedObjects: [
           Login {
               id: loginPage
           }
       ]
       layout: StackLayout {
       
       }
    }
    
    //Signal Handelers
    onUrlChanged: {
        console.log("profil url changed:  "+profilePage.profileUrl)
        proReq.url = profilePage.profileUrl
        proReq.sendUserReq()
    }
    
    attachedObjects: [
        GroupDataModel {
            id: profileDataModel
            sortedAscending: false
            grouping: ItemGrouping.None
            function addProfileInfo(d){ 
                console.log("addProfileInfo Called")  
                titleBar.titleText = d["name"]
                chat.setChannel(d["name"])
                console.log(d["logo"])
                profilePage.imageUrl = d["logo"]
                //profileImage.setUrl(d["logo"])
                profilePage.textBio = d["bio"]
                channelReq.url = "https://api.twitch.tv/kraken/channels/"+d["name"]
                +"?accept=application/vnd.twitchtv.v2+json"
                channelReq.sendChannelsReq()
            }
        },
        
        GroupDataModel {
            id: channelDataModel
            sortedAscending: false
            grouping: ItemGrouping.None
            function addChannelInfo(d){
                console.log("Adding channel info")
                console.log(d["background"])
                console.log(d["banner"])
                profilePage.backgroundUrl = (d["profile_banner"])

            }
        }    
    ]//end page attached objects
    
    onCreationCompleted: {
        OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        proReq.userAvailable.connect(profileDataModel.addProfileInfo)
        channelReq.channelsAvailable.connect(channelDataModel.addChannelInfo)
        
            var token = appSettings.getValueFor("AccessToken")
            console.log("Token on profile page is:  " + token)
            setUrl("https://api.twitch.tv/kraken/user")
    }
    function setUrl(u){
        profilePage.profileUrl = u
        urlChanged()
    }
    
    function logout(){
//        loginPage.clearCookies()
        o1.unlink()
        refreshMain() // assumes that Profile is attached to main.qml
    }
    actions: [
        ActionItem {
            id: logoutAction
            title: "Logout"
            ActionBar.placement: ActionBarPlacement.OnBar
            imageSource: "asset:///images/ic_action_logout.png"
            onTriggered: {
                logout()
            }
        }
    ] 
}   


