import bb.cascades 1.3
import bb.data 1.0
import org.labsquare 1.0

Container {
    id: imageContainer

    property alias image: webImage.url
    property alias secondary: secondary.text
    property alias channel: channelName.text
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Center
    preferredHeight: ui.du(62)
    preferredWidth:  ui.du(120)
    layout: DockLayout {}

    ImageView {
        id: placeholder
        preferredWidth: imageContainer.preferredWidth
        preferredHeight: imageContainer.preferredHeight
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
        imageSource: "asset:///images/channel_placeholder.jpg"

    }
    WebImageView {
        id: webImage
        url: "asset:///images/channel_placeholder.jpg"
        scalingMethod: ScalingMethod.AspectFill
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Top
        preferredWidth: imageContainer.preferredWidth
        preferredHeight: imageContainer.preferredHeight

    }
    ImageView {
        id: gradient
        imageSource: "asset:///images/channel_gradient.png"
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Bottom
        scalingMethod: ScalingMethod.AspectFill
        preferredWidth: imageContainer.preferredWidth
        preferredHeight: imageContainer.preferredHeight
    }
    
    Container {
        id: textContainer
        //horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Bottom
        preferredWidth: imageContainer.preferredWidth
        preferredHeight: ui.du(11)
        layout: DockLayout {}
        leftPadding: ui.du(1.0)
        rightPadding: ui.du(1.0)
        bottomPadding: ui.du(1.0)
        Label {
            id:channelName
            text: "Channel"
            horizontalAlignment: HorizontalAlignment.Left
            textFormat: TextFormat.Plain
            textStyle.color: Color.White
            textStyle.fontWeight: FontWeight.Bold
            textStyle.fontSize: FontSize.Large
            verticalAlignment: VerticalAlignment.Top
            textFit {
                minFontSizeValue: 3
                maxFontSizeValue: 25
            }
        }
        Label {
            id: secondary
            text: "Default"
            horizontalAlignment: HorizontalAlignment.Left
            textFormat: TextFormat.Plain
            textStyle.color: Color.create("#B9A3E3")
            multiline: false
            verticalAlignment: VerticalAlignment.Bottom
            textFit {
                
                minFontSizeValue: 3
                maxFontSizeValue: 17
            }
        }
    }
   
   
    onCreationCompleted: {
        //console.log("New Game object completed")
        //testData.load()
    }

    function setup(Object){
    
    
    }
    
    function test(d){
        //var j = JSON.parse(testData)
        // label.text = d["game"]["name"].toString()
    } 
    
}  



/*
 * 
 * 
 */
