import bb.cascades 1.3
import bb.data 1.0
import org.labsquare 1.0
import org.Hill 1.0


Page{
    property alias title : titleBar.titleText
    property alias  fromGames : listItem.fromGames
    property string orientation
    
    id: channelsPage
    titleBar: TitleBar {
        kind: TitleBarKind.FreeForm
        kindProperties: FreeFormTitleBarKindProperties {
            Titlebar {
                id:titleBar
                //defined in Titlebar.qml
            }
        }
        id: channelTitle
        visibility: ChromeVisibility.Overlay
    
    }
    actionBarVisibility: ChromeVisibility.Hidden
    Container{
        id: listContainer
        property bool fromGames: true
        horizontalAlignment: HorizontalAlignment.Center
        ListView {
            layout:  GridListLayout {
                orientation: LayoutOrientation.TopToBottom
                columnCount: 1
                cellAspectRatio: 1.8
                verticalCellSpacing: ui.du(1.5)
                horizontalCellSpacing: ui.du(1.5)
            }
            id: listView
            dataModel: channelsDataModel
            horizontalAlignment: HorizontalAlignment.Center
            listItemComponents: [
                ListItemComponent {
                    property bool fromGames : false
                    id: listItem
                    type: "item"
                    CustomListItem {
                        highlightAppearance: HighlightAppearance.Full
                        dividerVisible: false
                        Channel {
                            id: channel
                            secondary: ListItemData.game + ":  "+ ListItemData.viewers + " viewers"
                            channel: ListItemData.channel.display_name
                            image: ListItemData.preview.large
                        }
                        onCreationCompleted: {
                            if(ListItem.component.fromGames){
                                channel.secondary = ListItemData.viewers + " viewers"
                            }
                        }
                    }
                }          
            ]
            //Action to push channels on stack
            onTriggered: {
                select(indexPath, true)
                var i = dataModel.data(indexPath)
                //channelsReq.url = 'http://api.twitch.tv/api/channels/'+i.channel.name+'/access_token'
                var page
                if(appSettings.getPlayer() == "streamv2.qml"){
                    page = streamsDef.createObject();
                }else{
                    page = htmlstreamsDef.createObject()
                }
                
                page.setURL(i.channel.name)
               // page.sendVideoTokenRequest()
               // page.setURL(i.channel.name)
                //channelsReq.invokeRequest("http://www.twitch.tv/"+i.channel.name+"/hls")
                
                root.push(page)
            }
            
            attachedObjects: [
                ListScrollStateHandler {
                    onAtEndChanged: {
                        if(atEnd && channelsNav.channelsNext != "null"){
                            //console.log("At end of list...")
                            //console.log("Next Link is:  " + channelsNav.channelsNext)
                            channelsReq.url = channelsNav.channelsNext
                            channelsReq.sendChannelsReq()
                        }
                    }
                },
                OrientationHandler {
                    id: orientationHandler
                    onOrientationChanged: {
                        setLayout()
                    } // end of onOrientationAboutToChange
                }
            ]
            topPadding: ui.du(5.0)
            leftPadding: ui.du(1.5)
            rightPadding: ui.du(1.5)

        }//end of list view
        attachedObjects: [
            
            GroupDataModel {
                id: channelsDataModel
                sortedAscending: false
                grouping: ItemGrouping.None
                sortingKeys: ["viewers"]
                
                function addStreams(d){
                    console.log("add streams function called")
                    var data = d
                    console.log(data["_total"])
                    if(data["streams"] != null){
                        console.log("data[\"streams\"] is not null...")
                        channelsDataModel.clear()
                        channelsDataModel.insertList(data["streams"])
//                        channelsNav.channelsNext = data["_links"].next
                        setLayout()
                    }
                    
                    //console.log(data.streams[0].preview.toString())
                }
            },
            ComponentDefinition {
                id: streamsDef
                source: "streamv2.qml"
            },
            ComponentDefinition {
                id: htmlstreamsDef
                source: "stream.qml"
            },
            
            ComponentDefinition {
                id: navPage
                source: "GamesPage.qml"    
            },
            
            Navigator {
                id:channelsNav
            },
            RequestM {
                id: channelsReq
                url: "https://api.twitch.tv/kraken/streams"
            }
            
        ]
        onCreationCompleted: {
            //TODO Add check so not always called.
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
            channelsReq.channelsAvailable.connect(channelsDataModel.addStreams)
//            channelsReq.sendChannelsReq();
            
        }
    }
    function setURL(u){
        channelsReq.url = u
        console.log("channels setURL input:  " + u)
        console.log("channelsReq.url:  " + channelsReq.url)
    }
    function getStreams(){
        channelsDataModel.clear()
        channelsReq.sendChannelsReq()
    }
    
    
    function setLayout(){
        console.log("Setting layout")
        if(OrientationSupport.orientation == UIOrientation.Portrait){
            console.log("Setting layout to portrait")
            listView.layout.columnCount = 1
            listView.layout.orientation = LayoutOrientation.TopToBottom 
        }else if(OrientationSupport.orientation == UIOrientation.Landscape){
            console.log("Setting layout to lanscape")
            listView.layout.columnCount = 2
            listView.layout.orientation = LayoutOrientation.TopToBottom
        }
    }
}