import bb.cascades 1.3
import bb.data 1.0
import org.labsquare 1.0
import org.Hill 1.0
NavigationPane {
    id: root
    property string channelNext
    property string userNext
    property string userName
    
    Page {
        
        id: followingPage
        titleBar: TitleBar {
            kind: TitleBarKind.FreeForm
            kindProperties: FreeFormTitleBarKindProperties {
                Titlebar {
                    titleText: "Following"
                }
            }
            id: gamesTitle
            visibility: ChromeVisibility.Visible
        
        }
        actionBarVisibility: ChromeVisibility.Hidden
        
        Container{
            id: main

            SegmentedControl {
                id: followingControl
                
                Option {
                    id: online
                    text: "Streams"
                    selected: true
                }
                
                Option {
                    id: offline
                    text: "Users"
                    }
                    onSelectedOptionChanged: {
                        if(selectedOption == online){
                            offlineView.visible = false
                            onlineView.visible = true
                        }
                        if(selectedOption == offline){
                            offlineView.visible = true
                            onlineView.visible = false
                        }
                    
                    }
            }
            
            Container {
                id: onlineView
                visible: true
                horizontalAlignment: HorizontalAlignment.Center
                leftPadding: ui.du(1.5)
                rightPadding: ui.du(1.5)
                ListView {
                    layout:  GridListLayout {
                        orientation: LayoutOrientation.TopToBottom
                        columnCount: 1
                        cellAspectRatio: 1.7
                        verticalCellSpacing: 10
                    }
                    
                    id: listView
                    visible: false
                    dataModel: onlineDataModel
                    horizontalAlignment: HorizontalAlignment.Center
                    listItemComponents: [
                        ListItemComponent {
                            id: item
                            type: "item"
                            CustomListItem {
                                highlightAppearance: HighlightAppearance.Full

                                Channel {
                                    secondary: ListItemData.game + ":  "+ ListItemData.viewers + " viewers"
                                    channel: ListItemData.channel.display_name
                                    image: ListItemData.preview.large
                                }
                            }
                        }          
                    ]
                    //Action to push channels on stack
                    onTriggered: {
                        var i = dataModel.data(indexPath)
                        channelsReq.url = 'http://api.twitch.tv/api/channels/'+i.channel.name+'/access_token'
                        var page 
                        if(appSettings.getPlayer()=="streamv2.qml"){
                            page = streamsDef.createObject();
                        }else{
                            page = htmlstreamsDef.createObject()
                        }
                        page.setURL(i.channel.name)
                        //page.setURL('http://api.twitch.tv/api/channels/'+i.channel.name+'/access_token')
                        //page.sendVideoTokenRequest()
                        root.push(page)
                    }
                    
                    attachedObjects: [
                        ListScrollStateHandler {
                            onAtEndChanged: {
                                if(atEnd && channelNext != "null"){
                                    //console.log("At end of list...")
                                    //console.log("Next Link is:  " + channelsNav.channelsNext)
                                    channelsReq.url = channelNext
                                    channelsReq.sendChannelsReq()
                                }
                            }
                        }
                    ]
                
                }//end of list view
                Label {
                    visible: true
                    id: notification
                    text: "Doesn't look like anyone is online...."
                    textStyle.fontWeight: FontWeight.Normal
                    textStyle.fontSize: FontSize.Large
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                }
            }//End of Online container
            
            
            Container {
                id: offlineView
                leftPadding: ui.du(1.5)
                rightPadding: ui.du(1.5)
                visible: false
                ListView {
                    layout:  GridListLayout {
                        orientation: LayoutOrientation.TopToBottom
                        columnCount: 1
                        cellAspectRatio: 5.5
                        verticalCellSpacing: ui.du(1.5)
                    }
                    
                    id: usersListView
                    dataModel: usersDataModel
                    horizontalAlignment: HorizontalAlignment.Center
                    listItemComponents: [
                        ListItemComponent {
                            id: userItem
                            type: "item"
                            CustomListItem {
                                highlightAppearance: HighlightAppearance.Full

                                User {
                                    id: standardListUser
                                    name: ListItemData.channel.name
                                    status: "Views:  " + ListItemData.channel.views
                                    image: ListItemData.channel.logo
                                    description: ListItemData.channel.status
                                }
                             }
                        }          
                    ]
                    //Action to push channels on stack
                    onTriggered: {
                        var i = dataModel.data(indexPath)
                        var page = profilePage.createObject();
                        page.setUrl("https://api.twitch.tv/kraken/users/"+i.channel._id)
                        page.channel = i.channel._id
                        page.account = root.userName
                        console.log("root.username is:  " + root.userName)
                        root.push(page)
                    }
                    
                    attachedObjects: [
                        ListScrollStateHandler {
                            onAtEndChanged: {
                                if(atEnd && channelNext != "null"){
                                    //console.log("At end of list...")
                                    //console.log("Next Link is:  " + channelsNav.channelsNext)

                                }
                            }
                        }
                        ]
                    leftPadding: ui.du(1.0)
                    rightPadding: ui.du(1.0)

                }//end of list view
            }

            attachedObjects: [
                
                GroupDataModel {
                    id: onlineDataModel
                    sortedAscending: false
                    grouping: ItemGrouping.None
                    
                    function addStreams(d){
                        console.log("add streams function called")
                        var data = d
                        console.log(d)
                        if(data["_total"] == 0){
                            console.log("no one online")
                            notification.visible = true
                            listView.visible = false
                        } else {
                            notification.visible = false
                            listView.visible = true
                        }
                        onlineDataModel.insertList(data["streams"])
                        channelNext = data["_links"].next
                    }
                        
                        //console.log(data.streams[0].preview.toString())
                },
                
                GroupDataModel {
                    id: usersDataModel
                    sortedAscending: false
                    grouping: ItemGrouping.None
                    
                    function addUsers(d){
                        console.log("add users function called")
                        var data = d
                        console.log(data["total"])
                        usersDataModel.insertList(data["follows"])
                        console.log("addUsers finished")
                    }
                },
                
                ComponentDefinition {
                    id: streamsDef
                    source: "streamv2.qml"
                },
                ComponentDefinition {
                    id: htmlstreamsDef
                    source: "stream.qml"
                },
                
                ComponentDefinition {
                    id: navPage
                    source: "GamesPage.qml"    
                },
                
                ComponentDefinition {
                    id: profilePage
                    source: "OtherProfile.qml"
                },
    
                RequestM {
                    id: channelsReq
                    url: "https://api.twitch.tv/kraken/streams"
                    authenticator: o1
                },
                RequestM {
                    id: userReq
                    authenticator: o1
                },
                
                RequestM {
                    id:followsReq
                    authenticator: o1
                } 
                
                 
            ]
            onCreationCompleted: {
                //TODO Add check so not always called.
                OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
                
                channelsReq.channelsAvailable.connect(onlineDataModel.addStreams)
                userReq.userAvailable.connect(followingPage.setName)
                followsReq.userAvailable.connect(usersDataModel.addUsers)
                

                var url = "https://api.twitch.tv/kraken"+"/streams/followed/"
                followingPage.setURL(url)
                channelsReq.sendChannelsReq();
                userReq.url = "https://api.twitch.tv/kraken/user/"
                userReq.sendUserReq()
            }
        }
        function setURL(u){
            channelsReq.url = u
            console.log("channels setURL input:  " + u)
            console.log("channelsReq.url:  " + channelsReq.url)
        }
        function getStreams(){
            onlineDataModel.clear()
            channelsReq.sendChannelsReq()
        }
        function setName(d){
            userName = d._id
            followsReq.url = "https://api.twitch.tv/kraken/users/"+userName+"/follows/channels"
            followsReq.sendUserReq() 
        }
    }
    onPopTransitionEnded: {
        /*
        if(OrientationSupport.supportedDisplayOrientation != SupportedDisplayOrientation.DisplayPortrait){
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } */
        page.destroy(); 
    }
}