import bb.cascades 1.3
import bb.data 1.0
import org.labsquare 1.0
import org.Hill 1.0
import bb.device 1.3

NavigationPane {
    property string orientation
    id: root
    Page {
        id:gamesPage
        titleBar: TitleBar {
            kind: TitleBarKind.FreeForm
            kindProperties: FreeFormTitleBarKindProperties {
                Titlebar {
                    titleText: "Games"
                }
            }
            id: gamesTitle
            visibility: ChromeVisibility.Overlay
        
        }
        actionBarVisibility: ChromeVisibility.Hidden
        resizeBehavior: PageResizeBehavior.Resize
        actionBarAutoHideBehavior: ActionBarAutoHideBehavior.HideOnScroll
        Container{
            property alias url: req.url
            ListView {
                layout: GridListLayout {
                    columnCount: 3
                    orientation: LayoutOrientation.TopToBottom
                    horizontalCellSpacing: ui.du(1.5)
                    verticalCellSpacing: ui.du(1.5)
                    cellAspectRatio: 0.72
                }
                id: listView
                dataModel: dataModel
                
                listItemComponents: [
                    ListItemComponent {
                        id: customItem
                        type: "item"
                        CustomListItem {
                            highlightAppearance: HighlightAppearance.Full
                            dividerVisible: false
                            Container {
                                Game {
                                    id: gameItem
                                    //preferredWidth: ui.du(40)
                                    //preferredHeight: ui.du(55.6)
                                    text: ListItemData.game.name
                                    image: ListItemData.game.box.large
                                }
                            }
                           
                        }
                          
                    }     
                ]
                onTriggered: {
                    var i = dataModel.data(indexPath)
                    //console.log(i.game.name)
                    //req.url = "https://api.twitch.tv/kraken/search/streams?q="+i.game.name
                    var page = channelsDefinition.createObject(); //default channel urls are called
                    page.setURL("https://api.twitch.tv/kraken/streams?game="+i.game.name)
                    page.getStreams() // clears data and gets new data from set url
                    page.fromGames = true 
                    page.title = i.game.name
                    //activeGame.image = i.game.box.large
                    //activeGame.text  = i.game.name
                    root.push(page);
                }
                attachedObjects: [
                    ListScrollStateHandler {
                        onAtEndChanged: {
                            if(atEnd && nav.gamesNext != "null"){
                                console.log("At end of list...")
                                console.log("Next Link is:  " + nav.gamesNext)
                                req.url = nav.gamesNext
                                //requestMngr.sendNewRequest()
                                req.sendGamesReq()
                            }
                        }
                    },
                    OrientationHandler {
                        id: orientationHandler
                        onOrientationChanged: {
                            setLayout()
                        } // end of onOrientationAboutToChange
                    }
                ]
                topPadding: ui.du(5.0)
                scrollRole: ScrollRole.Main
                bottomPadding: 1.5

            }//end of list view
            RequestM {
                id: req
                //12 is max to fit on largest screen
                url: "https://api.twitch.tv/kraken/games/top?limit=24" //default url
            }
            attachedObjects: [
                
                GroupDataModel {
                    id: dataModel
                    sortedAscending: false
                    grouping: ItemGrouping.None
                    sortingKeys: ["viewers"]
                    
                    function addTopGames(d){
                        var data = d;
                        setLayout()
                        if(data["top"] != null){
                            dataModel.insertList(data["top"])
//                            nav.gamesNext = data["_links"].next
                        }
                    }
                },
                
                ComponentDefinition {
                    id: channelsDefinition
                    source: "ChannelsPage.qml"
                    
                },
                
                ComponentDefinition {
                    id: streamsDef
                    source: "streamv2.qml"
                },
                
                Navigator {
                    id: nav
                },
                
                // An Active Frame is a Scene Cover
                SceneCover {
                    id: sceneCover
                    content: Container {
                        id: container

                        layout: DockLayout {

                        }
                        
                        ImageView {
                            id:top
                            imageSource: "asset:///images/active_back.png"
                            verticalAlignment: VerticalAlignment.Center
                            horizontalAlignment: HorizontalAlignment.Center
                        }
                        ImageView {
                            id:bottom
                            maxHeight: 486
                            maxWidth: 440
                            minHeight: 486
                            minWidth: 440
                            imageSource: "asset:///images/active_frame_front.png"
                            verticalAlignment: VerticalAlignment.Center
                            horizontalAlignment: HorizontalAlignment.Center
                        }

                    }
                }
            ]
            onCreationCompleted: {
               //TODO Add check so not always called
               //Add scene cover to app
               Application.setCover(sceneCover)
               OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
               req.sendGamesReq();
               req.gamesAvailable.connect(dataModel.addTopGames)
               InvokedUrl.InvUrlChanged.connect(pushStream)
            }
            leftPadding: ui.du(1.5)
            rightPadding: ui.du(1.5)
        } 
    }

    onPopTransitionEnded: {
        /*
        if(OrientationSupport.supportedDisplayOrientation != SupportedDisplayOrientation.DisplayPortrait){
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } */
        page.destroy(); 
    }
    
    /*
     * 
     */
    function setURL(u){
        console.log("Game Page setURL called with input:  " + u)
        req.url = u
    }
    /*
     * 
     */
    function getGames(){
        req.sendGamesReq()
        //req.gamesAvailable.connect(dataModel.addTopGames)
    }
    
    
    function setLayout(){
        console.log("Setting layout")
        if(OrientationSupport.orientation == UIOrientation.Portrait){
            console.log("Setting layout to portrait")
            listView.layout.columnCount = 3
            listView.layout.orientation = LayoutOrientation.TopToBottom 
        }else if(OrientationSupport.orientation == UIOrientation.Landscape){
            console.log("Setting layout to lanscape")
            listView.layout.columnCount = 5
            listView.layout.orientation = LayoutOrientation.TopToBottom 
        }
    }
    function pushStream(){
        
        if(InvokedUrl.getInvUrl()=="null"){
            console.log("URL from invocation is null")
            return 
        }
        
        console.log("Stream about to be pushed....")
        var page = streamsDef.createObject();
        page.setURL(InvokedUrl.getInvUrl())
        InvokedUrl.setInvUrl("null");
        root.push(page)
        
    }
        
    
}