import bb.cascades 1.3
import org.Hill 1.0

Container {
    property bool loggedIn
    id:chatContainer
    visible: false
    property string oauth
    property string username
    
    property alias channel: irc.channel
    
    Irc {
        id: irc
        host: "irc.chat.twitch.tv"
        port: 6667
        nickname: o1.linked ? o1.extraTokens.name : "justinfan" + Math.random().toString().substring(2, 7)
        identity: ""
        realName: ""
        password: o1.linked ? "oauth:" + o1.token : "whatever"
        channel: ""
    
    }
    
    Container {
        bottomPadding: ui.du(10.5)
        ScrollView {
            scrollViewProperties.pinchToZoomEnabled: false

            scrollViewProperties.maxContentScale: 1.0
            scrollViewProperties.minContentScale: 1.0
            WebView {
                id: webChat
                settings.textAutosizingEnabled: false
                settings.defaultFontSizeFollowsSystemFontSize: false
                settings.cookiesEnabled: false
                settings.zoomToFitEnabled: true
                settings.defaultFontSize: 28
                settings.webInspectorEnabled: false
                
                url: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright ? "local:///assets/chat.html" : "local:///assets/chat_dark.html"

                onMessageReceived: {
                    // Init here instead of onCreationCompleted, takes into account browser engine load time
                    init()
                }
                
//                onJavaScriptResult: {
//                    console.debug(result)
//                }
            }
        }
    }
    Label {
        visible: false
        id: loginLable
        text: "Please Login to use chat"
        textStyle.fontWeight: FontWeight.Normal
        textStyle.fontSize: FontSize.XLarge
        verticalAlignment: VerticalAlignment.Center
        horizontalAlignment: HorizontalAlignment.Center
    }


    TextArea {
        id: tarea
        minHeight: ui.du(10)
        maxHeight: ui.du(20)
        inputMode: inputMode.Chat
        hintText: {
            if(!enabled)
                return "                   Please login to use chat"
            if(irc.restriction_type == 1)
                return "                   Enter Message (chat is emote-only)"
            if (irc.restriction_type == 2){
                if(irc.subscriber)
                    return "                   Enter Message (chat is subs-only)"
                else
                    return "                   Enter Message (chat is subs-only and you're not subscribed!)"
            }
            if (irc.restriction_type == 3)
                return "                   Enter Message (chat is followers-only)"
            if (irc.restriction_type == 4)
                return "                   Enter Message (chat is in slow mode)"
            return "                       Enter Message"
        }
        
        verticalAlignment: VerticalAlignment.Bottom
        horizontalAlignment: HorizontalAlignment.Center
        
        enabled: true
        input {
            submitKey: SubmitKey.Send
            onSubmitted: {
                irc.PRIVMSG(text)
                //textData.append(text)
                text = ""
            }
        }
        
    }
    
    attachedObjects: [
        ArrayDataModel {
            id: textData
        },
        RequestM {
            id: userReq
        }
    ]
    
    function init() {
        //irc.connectIRC()
        console.log("IRCCHAT CREATED")
        irc.textAvailable.connect(updateText)
//        userReq.userAvailable.connect(setNameFromReq)
        oauth = o1.token
        if(! o1.linked){
            console.log("NOT LOGGED IN")
            tarea.enabled = false
        }
        
        loggedIn = true    //needed to show chat
        loginLable.visible = false
        connectIRC()
    }

    layout: DockLayout {

    }

    function updateText(t){
        console.debug(t.text.toString())
        
        webChat.postMessage("colour: '"+t.colour+"', username: '"+t.username+"', text: '"+t.text+"'")
    }
    function connectIRC(){
        console.log("IRC connect called.")
        console.log("Nick is:  " + irc.nickname)
        console.log("password is:  " + irc.password)
        console.log("channel is:  " + irc.channel)
        console.log("port is:  " + irc.port)
        console.log("host is:  " + irc.host)
        
        irc.connectIRC()
    }
    function setChannel(c){
        console.debug("setChannel: " + c)
        irc.channel = c
    }
    function setName(n){
        irc.nickname = n
        irc.realName = n
        irc.identity = n
    }
    function setNameFromReq(n){
        console.log("set name called. User name is:  "+n.name)
        console.log("set name called. password is:  "+oauth)
        username = n.name;
        setName(username)
        setPassword("oauth:"+oauth)
        connectIRC()
    }
    function setPassword(p){
        irc.password = p
    }
    function getLoggedIn(){
        return loggedIn
    }
    function sendMessage(text){
        irc.PRIVMSG(text)
    }
    
    
}

