import bb.cascades 1.4
import com.simodax 1.0

Page {
    property string uri: "http://127.0.0.1:1965" 
    property string client: "fkga99ztp4o83qh8vupzcrmxy2n8ey"
    
    property string accessUrl: "https://id.twitch.tv/oauth2/authorize"
        +"?response_type=code"
        +"&client_id="+client
        +"&redirect_uri="+uri
        +"&scope=user_read+channel_read+user_follows_edit+chat:read+chat:edit"

//    property string accessUrl: "https://www.twitch.tv/login?client_id=rz8852rnpg26xa82h2d6tzdux4q12kt&redirect_params=client_id=rz8852rnpg26xa82h2d6tzdux4q12kt&redirect_uri=http%3A%2F%2Flocalhost&response_type=token&scope=user_read++channel_read++user_follows_edit++chat_login"
        
    onAccessUrlChanged: {
        _login.query.setUri(accessUrl)    //not sure binding is enough in invocation queries
    }
        
    Container {
        layout: DockLayout {
            
        }
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            leftPadding: ui.du(4)
            rightPadding: ui.du(4)
            Label {
//                text: "To login, make sure the device browser is in Desktop mode (tap on Settings > Developer tools > Desktop mode)\n" +
//                      "Then click the button to be redirected to the login page"
                text: "Click the button to be redirected to the login page\n" +
                      "If it  fails to load, put the device browser is in Desktop mode (tap on Settings > Developer tools > Desktop mode)"
//                text: "Login is not yet available  ¯\\_(ツ)_/¯\n"+
//                      "Wait for the next version!"
                textStyle.fontSize: FontSize.Medium
                multiline: true
                bottomMargin: ui.du(5)
            }
            Button {
//                enabled: false
                text: "Login"
                horizontalAlignment: HorizontalAlignment.Center
                color: ui.palette.primaryDark
                onClicked: {
                    _login.trigger("bb.action.OPEN")
                }
            }
        }
        attachedObjects: [
            Invocation {
                id: _login
                query {
                    uri: accessUrl
                    invokeTargetId: "sys.browser"
                    onQueryChanged: {
                        updateQuery()
                    }
                }
            }
        ]
    }
   
}
