/*
 * Copyright (c) 2011-2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import bb.cascades 1.3
import bb.data 1.0
import com.simodax 1.0

TabbedPane {
    
    property string invokedUrl
    property bool invoked
    
    id: mainTabbed
    showTabsOnActionBar: false
    peekEnabled: true

    // Add the application menu using a MenuDefinition
    Menu.definition: MenuDefinition {
        
        //settingsAction: SettingsActionItem {}
        //helpAction: HelpActionItem {}
        
        // Specify the actions that should be included in the menu
        actions: [
            
            ActionItem {
                title: "About"
                imageSource: "images/Action_Icons/ic_info.png"
                
                onTriggered: {
                    var a = about.createObject();
                    a.open()
                    //activeTab.root.push(a)

                }
            },
            
            ActionItem {
                title: "Settings"
                imageSource: "images/Action_Icons/ic_settings.png"
                
                onTriggered: {
                    onTriggered: {
                        var a = settings.createObject();
                        a.open()
                    }
                }
            },
            
//            ActionItem {
//                title: "Help"
//                imageSource: "images/Action_Icons/ic_help.png"
//                
//                onTriggered: {
//                    var a = help.createObject();
//                    a.open()
//                }
//            },
            ActionItem {
                title: "Donate"
                imageSource: "images/Action_Icons/ic_donate.png"
                
                onTriggered: {
                    var a = dontate.createObject();
                    a.open()
                }
            }
        ] // end of actions list
        attachedObjects: [
            ComponentDefinition {
                id: about
                source: "about.qml"
            },
            ComponentDefinition {
                id: settings
                source: "Settings.qml"
            },
            ComponentDefinition {
                id: help
                source: "Help.qml"
            },
            
            ComponentDefinition {
                id: dontate
                source: "Donate.qml"
            }
        ]
    } // end of MenuDefinition
    
    
    Tab {
        id: accountTab
        imageSource: "asset:///images/Action_Icons/ic_contacts.png"
        description: "Account"
        delegate: Delegate {
            id: accountDelegate
            source: "AccountProfile.qml"
        
        }
        delegateActivationPolicy: TabDelegateActivationPolicy.None
    }
    Tab {
        id: loginTab
        imageSource: "asset:///images/Action_Icons/ic_contacts.png"
        description: "Login"
        delegate: Delegate {
            id: loginDelegate
            source: "Login.qml"
        
        }
        delegateActivationPolicy: TabDelegateActivationPolicy.None
    }
    
    Tab {
        id: followingTab
        description: "Following"
        imageSource: "asset:///images/ic_action_follow_up.png"
        delegate: Delegate {
            id: followingDelegate
            source: "Following.qml"
        }
        delegateActivationPolicy: TabDelegateActivationPolicy.None
    }
    Tab {
        id: gamestab
        imageSource: "asset:///images/icon_games_default.png"
        description: "Games"
       // imageSource: 
        delegate: Delegate {
            id: tabDelegate1
            source: "GamesPage.qml"
        }
        delegateActivationPolicy: TabDelegateActivationPolicy.ActivateImmediately
    }
    
    Tab {
        id: channelstab
        imageSource: "asset:///images/icon_channels_default.png"
        description: "Channels"
        delegate: Delegate {
            id: tabDelegate2
            source: "Channels.qml"
        }
        delegateActivationPolicy: TabDelegateActivationPolicy.None
        onCreationCompleted: {
            
        }
    }
    
    Tab {
        id: searchTab
        description: "Search"
        imageSource: "asset:///images/Action_Icons/ic_search.png"
        delegate: Delegate {
            id: searchDelegate
            source: "search.qml"
        }
    }
    
    
    onActiveTabChanged: {
        if (activeTab == gamestab) {
            tabDelegate1.active = true;
            tabDelegate2.active = false;
            accountDelegate.active = false;
            searchDelegate.active = false;
            loginDelegate.active = false;
            followingDelegate.active = false;

        }
        if (activeTab == channelstab) {
            tabDelegate1.active = false;
            tabDelegate2.active = true;
            accountDelegate.active = false;
            searchDelegate.active = false;
            loginDelegate.active = false;
            followingDelegate.active = false;
        }
        if (activeTab == accountTab) {
            tabDelegate1.active = false;
            tabDelegate2.active = false;
            accountDelegate.active = true
            searchDelegate.active = false;
            loginDelegate.active = false;
            followingDelegate.active = false;
        }
        if (activeTab == searchTab) {
            tabDelegate1.active = false;
            tabDelegate2.active = false;
            accountDelegate.active = false;
            searchDelegate.active = true;
            loginDelegate.active = false;
            followingDelegate.active = false;
        }
        if (activeTab == loginTab) {
            tabDelegate1.active = false;
            tabDelegate2.active = false;
            accountDelegate.active = false;
            searchDelegate.active = false;
            loginDelegate.active = true;
            followingDelegate.active = false;
        }
        if (activeTab == followingTab) {
            tabDelegate1.active = false;
            tabDelegate2.active = false;
            accountDelegate.active = false;
            searchDelegate.active = false;
            loginDelegate.active = false;
            followingDelegate.active = true;
        }
    }

    
    onCreationCompleted: {
        refreshMain()
        Relay.logoPressed.connect(mainTabbed.showSideBar)
        mainTabbed.activeTab = gamestab
        tabDelegate1.active = true;
        console.log("Access token null?  " + o1.token)
        
        if(o1.linked)
            o1.validateToken();
    }
    paneProperties: NavigationPaneProperties {
    }
    sidebarState: SidebarState.VisibleCompact
    
    
    /*Function to refresh page*/
    function refreshMain(){
        console.log("Refresh main page")
        //if not logged in
        if(!o1.linked){
            mainTabbed.remove(accountTab)
            mainTabbed.remove(followingTab)
            mainTabbed.add(loginTab)
            //remove following
            
        }else{
            mainTabbed.remove(loginTab)
            mainTabbed.add(accountTab)
            mainTabbed.add(followingTab)
        }
    }
    onInvokedUrlChanged: {
        if(invokedUrl == "null") {
            console.log("onInvokedUrlChanged: is null. Returning")
            return 
        }
        
        console.log("The invoked url property of tabbed pane was changed")
        mainTabbed.activeTab = gamestab
        var indexofchannel = invokedUrl.lastIndexOf("/");
        var channel = invokedUrl.slice(indexofchannel+1)
        InvokedUrl.setInvUrl(channel);
        invokedUrl = "null"
        //set invoke url property in games tab
    }
    
    function showSideBar(){
        console.log("showSideBar() called")
        mainTabbed.sidebarState = SidebarState.VisibleFull

    }
    
    attachedObjects: O1Twitch {
        id: o1
        onLinkingSucceeded: {
            if(o1.linked)
                o1.updateUserData()
        }
        onUserDataUpdated: {
            refreshMain()
            showSideBar()
        }
    }
}
