import bb.cascades 1.3
import bb.multimedia 1.2
// ...

Page {
    Container {
        // ...
        
        attachedObjects: [
            MediaPlayer {
                id: player
                sourceUrl: 'http://www.twitch.tv/'+"Zfg1"+'/'
                
                // Set these properties for video
                videoOutput: VideoOutput.PrimaryDisplay
                windowId: fwcVideoSurface.windowId
                
                onMediaStateChanged: {
                    switch (player.mediaState) {
                        case MediaState.Unprepared:
                            break;
                        case MediaState.Prepared:
                            break;
                        // ...
                    }
                }
            }
        ]
        
        
        ForeignWindowControl {
            id: fwcVideoSurface
            windowId: "myVideoSurface"
            visible: boundToWindow
            
            updatedProperties: WindowProperty.Size |
            WindowProperty.Position |
            WindowProperty.Visible
        }
        
        // ...
        
        Button {
            id: btnPlay
            text: "Play"
            onClicked: {
                if (player.play() != MediaError.None) {
                    // Your error handling code here.
                }
            }
        }
        
        Button {
            id: btnStop
            text: "Stop"
            onClicked: {
                player.stop();
            }
        }
        
        Button {
            id: btnReset
            text: "Reset"
            onClicked: {
                player.reset();
            }
        }
    }
}
