import bb.cascades 1.3
import bb.multimedia 1.2
import bb.device 1.3
import org.Hill 1.0
// ...

Page {
    
    property string username
    property string channel
    property string orientation;
    property string url;
    property string shareurl;
    property double aspect: 0.55;
    property string thisChannel;
    
    id: streamPage
    resizeBehavior: PageResizeBehavior.Resize
    actionBarFollowKeyboardPolicy: ActionBarFollowKeyboardPolicy.Never
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.HideOnScroll
    
    
    actions: [
        ActionItem {
            id: action1
            title: "View Profile"
            imageSource: "asset:///images/Action_Icons/ic_contacts.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            
            onTriggered: {
                var page = profilePage.createObject();
                page.setUrl("https://api.twitch.tv/kraken/users/"+getChannel())
                //THis broke it.... not idea why just yet...
                page.channel = getChannel();
                console.log("About to push page onto stack....")
                root.push(page)
            }
        },
        InvokeActionItem {
            id: share
            title: "Share"
            imageSource: "asset:///images/Action_Icons/ic_share.png"
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.SHARE"
                //data: THis is set further down in set url function.
            }
            onTriggered: {
                //setData(streamView.url);
                //console.log(data);
            }
        },
        ActionItem {
            id: browser
            title: "Open in Browser"
            imageSource: "asset:///images/Action_Icons/ic_open_link.png"
            
            onTriggered: {
                invokeBrowser.query.setUri(url)
                invokeBrowser.trigger("bb.action.OPEN") 
            }
        }
    ]

    Container {
        id: webLayouts
    
        layout: StackLayout {

        }
        
            
            WebView {
                id: streamView
                preferredWidth : ui.du(120)
                //preferredHeight: ui.du(preferredWidth*0.65)//preferredWidth*0.55
                //url: 'http://www.twitch.tv/'+"Zfg1"+'/hls'
                //horizontalAlignment: HorizontalAlignment.Fill
                //settings.zoomToFitEnabled: true
                //settings.defaultFontSizeFollowsSystemFontSize: true
                //settings.viewport: {"width" : "device-width", "height" : "device-height", "initial-scale" : 0.7}
                settings.viewport: { "initial-scale" : 0.7 }
                settings.javaScriptEnabled: true
                
                onNavigationRequested: {
                    request.action.Ignore
                    if(request.navigationType == 1000 ){
                        /*
                         var nextpage = addDef.createObject();
                         nextpage.setUrl(request.url)
                         root.push(nextpage)
                         */
                        invokeBrowser.query.setUri(request.url)
                        invokeBrowser.trigger("bb.action.OPEN")
                    }
                
                }
                
                onNewViewRequested: {
                    console.log("New View requested")
                
                }
            horizontalAlignment: HorizontalAlignment.Center
            settings.cookiesEnabled: false

        }  


      
        IrcChat {
            verticalAlignment: VerticalAlignment.Bottom
            id: chat
        }
         
        RequestM {
            id: tokenManager
            url: null
        }
        
        //TODO Second request manager to avoid error
        RequestM {
            id: videoURLManager
        }
        RequestM {
            id: userReq
        }
        attachedObjects: [
            ComponentDefinition {
                id: addDef
                source: "AddPage.qml"
            }, 

            DisplayInfo {
                    id: display
            },
        
            OrientationHandler {
                id: orientationHandler
                onOrientationAboutToChange: {
                    switchOrientation()
                    setStreamDimensions()
                } // end of onOrientationAboutToChange
            },
            // This handler is tracking the layout frame of the button.
            LayoutUpdateHandler {
                id: layoutHandler
                onLayoutFrameChanged: {
                    // Individual layout frame values can be
                    // retrieved from the signal parameter
                    console.log("Layout Frame: [" +
                    layoutFrame.x + ", " + layoutFrame.y + ", " +
                    layoutFrame.width + ", " + 
                    layoutFrame.height + "]");
                    //streamView.settings.viewport = {"width" : "device-width", "height" : "device-height"}
                }
            },
            NowPlayingConnection {
                id: nowplaying
                
                connectionName: "myConnection"
                
                onAcquired: {
                    //var metadata = { "track": "MyTrack", "artist" : "MyArtist" };
                    
                    //nowplaying.duration = 120000; // 2min in milliseconds
                    //nowplaying.position = 0;
                    
                   //nowplaying.mediaState = MediaState.Started;
                    
                    //nowplaying.setMetaData(metadata);
                    console.log("MetaData:  " + nowplaying.mediaState)
                }
                
            },
            
            Invocation {
                id: invokeBrowser
                query {
                    invokeActionId: "bb.action.OPEN"
                    invokeTargetId: "sys.browser"    
                    onQueryChanged: {
                        query.updateQuery()
                    }
                }
                onArmed: {
                    trigger("bb.action.OPEN")
                }

            },
            ComponentDefinition {
                id: profilePage
                source: "OtherProfile.qml"
            }
        ]
        margin.leftOffset: 0
        margin.rightOffset: 0
        background: Color.Transparent

    }// end root container
    onCreationCompleted: {
        OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        setStreamDimensions()
        chat.setChannel(channel)
        
        /*open add page*/
        
    }

    actionBarVisibility: ChromeVisibility.Visible
    function setURL(c) {
        //setHTML(channel)
        //streamView.url = "http://usher.justin.tv/api/channel/hls/"+channel+".m3u8"
        streamView.url = "http://www.twitch.tv/"+c+"/hls"
        shareurl = "http://www.twitch.tv/"+c
        url = streamView.url
        
        console.log("streamView.url is:  " + streamView.url.toString())
        share.setData(shareurl)
        share.query.updateQuery()
        chat.setChannel(c)
        channel = c
        
    }
    
    function setURLFromFull(c) {
        //setHTML(channel)
        //streamView.url = "http://usher.justin.tv/api/channel/hls/"+channel+".m3u8"
        streamView.url = c + "/hls"
        shareurl = c
        url = streamView.url
        
        console.log("streamView.url is:  " + streamView.url.toString())
        share.setData(shareurl)
        share.query.updateQuery()
        chat.setChannel(c)
        channel = c
    
    }
    
    function setHTML(channel){
        console.log("Channel setting to:  " +channel)
        streamView.html = "<iframe id=\"player\"" +
        "type=\"text/html\""
        +"width=\""+"100%"+"\""
        +"height=\""+"100%"+"\""
        +"src=\"http://www.twitch.tv/"+channel+"/embed\""
        +"frameborder=\"-1\"></iframe>"       
        //streamView.reload()
    }

    function getURLS(d){
        console.log("setURLS called, url request successful")
        console.log(d)
        streamView.url = d
        //videoURLManager.invokeRequest(d)
        //videoPlayer.play()
        //console.log(videoPlayer.videoDimensions.width)
    }
    
    function sendVideoTokenRequest(){
        tokenManager.sendVideoTokenReq()
    }
    // Set current orientation
    function switchOrientation() {
        if(orientationHandler.orientation == UIOrientation.Landscape){
            orientation = "portrait"
        }
        else{
            orientation = "landscape"
        }
    }
    function setOrientation(){
        if(orientationHandler.orientation == UIOrientation.Landscape){
            orientation = "landscape"
        }
        else{
            orientation = "portrait"
        }
    }
    function setStreamDimensions(){
        console.log("Orientation Change")
        if (orientation == "landscape") {
            actionBarVisibility = ChromeVisibility.Hidden
            streamView.preferredWidth = display.pixelSize.height
            streamView.preferredHeight = display.pixelSize.width
            //webLayouts.background = Color.Black
            streamView.verticalAlignment.Center
            chat.visible = false

        
        } else {
            actionBarVisibility = ChromeVisibility.Compact
           streamView.preferredWidth = display.pixelSize.height
           streamView.preferredHeight = display.pixelSize.width*aspect
           chat.visible = true
           //webLayouts.background = Color.White
           streamView.verticalAlignment.Top
        }
    }
    
    function getChannel(){
        return channel
    }

}
