import bb.cascades 1.3
import bb.multimedia 1.2
import bb.device 1.3
import org.Hill 1.0


  
Page {
    property string channel;
    // string to hold orientation
    property string orientation;
    property variant urlMap; 
    //has inital metaData
    property bool meta;
    property double aspect: 9 / 16.0;
    property string newOrientation;
    property bool fullscreen;
    
    actionBarVisibility: ChromeVisibility.Compact
    actionBarFollowKeyboardPolicy: ActionBarFollowKeyboardPolicy.Never
    
    actions: [
        ActionItem {
            id: action1
            title: "View Profile"
            imageSource: "asset:///images/Action_Icons/ic_contacts.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            
            onTriggered: {
                var page = profilePage.createObject();
                page.setUrl("https://api.twitch.tv/kraken/users/"+getChannel())
                //THis broke it.... not idea why just yet...
                page.channel = getChannel();
                console.log("About to push page onto stack....")
                root.push(page)
            }
        },
        
        ActionItem {
            id: fullscreenAction
            title: "Fullscreen"
            imageSource: "asset:///images/Action_Icons/ic_open.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            
            onTriggered: {
                if(fullscreen == false){
                    hideChat()
                    fullscreenAction.title = "Minimize"
                }else{
                    displayChat()
                    fullscreenAction.title = "Fullscreen"
                }
                    
            }
        },
  
        ActionItem {
            id: playon
            title: "Play On"
            imageSource: "asset:///images/Action_Icons/ic_play.png"
            
            onTriggered: {
                videoURLManager.playOn()
                //videoPlayer.setVideoOutput(VideoOutput.SecondaryDisplay)
            }
        },
        
        InvokeActionItem {
            id: share
            title: "Share"
            imageSource: "asset:///images/Action_Icons/ic_share.png"//"asset:///images/Action_Icons/ic_open.png"
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.SHARE"
                //data: THis is set further down in set url function.
            }
            onTriggered: {
                //setData(streamView.url);
                //console.log(data);
            }
        }
    ]
    
    Container {
        id: rootContainer
        //background: Color.White
        //background: Color.create("#262626")

        layout: StackLayout {

        }
        
            Container {
                //background: Color.create("#B9A3E3")
                DropDown {
                    
                    id: videoQualityPicker
                    title: "Quality"
                    visible: false
                    onSelectedOptionChanged: {
                        console.log("Option changed to: " + selectedOption.text + " url: " + urlMap[selectedIndex].url)
                        var newUrl = urlMap[selectedIndex].url
                        videoPlayer.reset()
                        videoPlayer.setSourceUrl(newUrl)
                        videoPlayer.play()
                        if(visible) visible = false
                        activityIndicator.setEnabled(true)
                        activityIndicator.setVisible(true)
                        //videoPlayer.sourceUrl = urlMap[selectedIndex].url
                    }

                    opacity: 0.9
                    function switchVisibility(){
                        if(visible == true){
                            visible = false
                        }else{
                            visible = true
                        }
                    }
    
                }

                attachedObjects: [
                    MediaPlayer {
                        id: videoPlayer
                        videoOutput: VideoOutput.PrimaryDisplay
                        windowId: fwcVideoSurface.windowId
                        //sourceUrl: "http://video8.ord01.hls.twitch.tv/hls75/syndicate_10840023280_136284309/mobile/index-live.m3u8?token=id=84640038241515500,bid=10840023280,exp=1409256986,node=video8-1.ord01.hls.justin.tv,nname=video8.ord01,fmt=mobile&sig=1965cd88ba283e65264ecf440b60dd7182b9ebbb"
                        onMetaDataChanged: {
                            if (videoDimensions.height != 0 && meta == false) {
                                setAspectRatio()
                                setStreamDimensions()
                                meta = true
                            }
                        }
                        onBufferStatusChanged: {
                            if(bufferStatus== BufferStatus.Playing){
                                activityIndicator.setEnabled(false)
                                activityIndicator.setVisible(false)
                            }else{
                                activityIndicator.setEnabled(true)
                                activityIndicator.setVisible(true)
                            }
                        }
                    },
                    NowPlayingConnection {
                        id: nowplaying
                        connectionName: "myConnection"
                        iconUrl: "asset:///images/new_logo480.png"
                        
                        onAcquired: {

                            console.log("MetaData:  " + nowplaying.mediaState)
                        }
                    
                    },
    
                    DisplayInfo {
                        id: display
                    },
    
                    OrientationHandler {
                        id: orientationHandler
                        onOrientationAboutToChange: {
                            switchOrientation()
                            setStreamDimensions()
                        } // end of onOrientationAboutToChange
                    },
                    GroupDataModel {
                        id: videoQualityMap
                        sortedAscending: false
                        grouping: ItemGrouping.None
                        onItemAdded: {
                            console.log("videoQualityMap has changed. Item added")
                        }
                    },
                    ComponentDefinition {
                        id: optionFactory
                        Option {
                        }
                    },
                    ComponentDefinition {
                        id: profilePage
                        source: "OtherProfile.qml"
                    }
                ]
                
                //foreignWindow for main media
                ForeignWindowControl {
                    property bool touchCapture
                    id: fwcVideoSurface
                    windowId: "myVideoSurface"
    
                    updatedProperties: WindowProperty.Size | WindowProperty.Position | WindowProperty.Visible
    
                    horizontalAlignment: HorizontalAlignment.Center
    
                    preferredWidth: display.pixelSize.width
                    preferredHeight: display.pixelSize.width * aspect
                    
                    onPreferredHeightChanged: {
                        console.debug("Preferred height: "+preferredHeight)
                    }
                /*
                    onTouchCapture: {
                        // If the touch event is received in the capture phase,
                        // update the label text and set the captured property
                        // to true (to prevent the text from being updated in
                        // the onTouch signal handler)
                        videoQualityPicker.switchVisibility()
                        fwcVideoSurface.touchCapture = true;
                    }*/
                    onTouch: {
                        if(event.touchType == TouchType.Up) videoQualityPicker.switchVisibility() 
                    }
                    
    
                }
    
                RequestM {
                    id: tokenManager
                }
    
                //TODO Second request manager to avoid error
                RequestM {
                    id: videoURLManager
                }
                
                ActivityIndicator {
                    id: activityIndicator
                    running: true
                    verticalAlignment: VerticalAlignment.Center
                    horizontalAlignment: HorizontalAlignment.Center

                }
    
        } //end scroll view
        Container {
            id: chatContainer
            IrcChat {
                id: chat
                visible: true
                channel: channel
            }
        }
    }//end root Container
    
    onCreationCompleted: {
        //streamReq.sendVideoTokenReq();
        OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        //initialize
        setOrientation()
        meta = false;
        tokenManager.videoTokenAvailable.connect(getTokens)
    }

    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.Default

    function getTokens(d) {
        console.log("getTokens Called")
        //console.log(d["token"])
        
        if(d[0] != null){
//            var tokenData = JSON.parse(d[0]['data']['streamPlaybackAccessToken'])
            var tokenData = (d[0]['data']['streamPlaybackAccessToken'])
//            var name = d[0]['data']['channel']
//            channel = name
            //var tokenString = JSON.stringify(tokenData)
            //console.log("Token Stringified:  " + tokenString)
            console.log(channel)
            videoURLManager.url = 'http://usher.ttvnw.net/api/channel/hls/'
                +channel+
                '.m3u8?player=twitchweb&token='
                +tokenData.value+
                '&sig='+
                tokenData.signature+
                '&allow_audio_only=true&allow_source=true&type=any'
            console.debug(videoURLManager.url)
            //videoURLManager.url = 'http://usher.ttvnw.net/api/channel/hls/' + name + '.m3u8?player=twitchweb&token=' + d["token"] + '&sig=' + d["sig"] + '&allow_audio_only=true&allow_source=true&type=any'
            //'http://usher.twitch.tv/select/'+name+'.json?nauthsig='+d["sig"]+';nauth='+d["token"]+';allow_source=false/'
            //console.log("VIDEO URL REQUEST:  " + requestMngr.url)
            /**
             * http://usher.twitch.tv/api/channel/hls/{CHANNEL}.m3u8?player=twitchweb&token={ENCODED_TOKEN}&sig={SIG}&allow_audio_only=true&allow_source=true&type=any&p={RANDOM}
             */
            

            videoURLManager.sendVideosReq()
            videoURLManager.videosAvailable.connect(getURLS)
            //console.log("Video Request sent")
            
        }else{
            console.log("Tokens request is null")
        }
    }
    function getURLS(d){
        console.log("setURLS called, url request successful")
        urlMap = d
        console.log(urlMap.length)
        for(var i = 0; i < urlMap.length; i++){
            console.log("Creating option....")
            var option = optionFactory.createObject()
            option.text = urlMap[i].title
            videoQualityPicker.add(option)
        }
        //set to high quality. Else, set to source
        if(urlMap[1]){
            videoQualityPicker.setSelectedIndex(1)
            videoPlayer.sourceUrl = urlMap[1].url
        }else{
            videoQualityPicker.setSelectedIndex(0)
            videoPlayer.sourceUrl = urlMap[0].url
        }
        
        //videoURLManager.invokeRequest(d)
        videoPlayer.play()
    }
    
    function setURL(c){
        var url = 'https://gql.twitch.tv/gql'
        tokenManager.url = url
        channel = c
        var shareurl = "http://www.twitch.tv/"+c
        sendVideoTokenRequest(c)
        share.setData(shareurl)
        share.query.updateQuery()
        chat.setChannel(c)
    }
    
    function getChannel(){
        return channel
    }
    function sendVideoTokenRequest(c){
        tokenManager.sendVideoTokenReq(c)
    }
    function setAspectRatio() {
        aspect = videoPlayer.videoDimensions.height/videoPlayer.videoDimensions.width;
        console.log("Aspect ratio calculated as:  " + aspect)
    }
    function setStreamDimensions(){
        console.log("Orientation Change")
        if (orientation == "landscape") {
            setFullScreen()
            
        } else {
            setMinimizedView()
        }
    }
    // Set current orientation
    function switchOrientation() {
        if(orientationHandler.orientation == UIOrientation.Landscape){
            orientation = "portrait"
        }
        else{
            orientation = "landscape"
        }
    }
    function setOrientation(){
        if(orientationHandler.orientation == UIOrientation.Landscape){
            orientation = "landscape"
        }
        else{
            orientation = "portrait"
        }
    }
    function setFullScreen(){
        chat.visible = false
        actionBarVisibility = ChromeVisibility.Hidden
        fwcVideoSurface.preferredWidth = display.pixelSize.height
        fwcVideoSurface.preferredHeight = fwcVideoSurface.preferredWidth*aspect
    }
    function setMinimizedView(){
        fwcVideoSurface.preferredWidth = display.pixelSize.width
        fwcVideoSurface.preferredHeight = fwcVideoSurface.preferredWidth*aspect
        chat.visible = true
        actionBarVisibility = ChromeVisibility.Compact
    }
    
    function hideChat(){
        chat.visible  = false
        fullscreen    = true
        actionBarVisibility = ChromeVisibility.Compact
        //rootContainer.setBackground()
        
    }
    function displayChat(){
        chat.visible  = true
        fullscreen    = false
        actionBarVisibility = ChromeVisibility.Compact
        
    }
        
}//end page
